#pragma once

#include "config.h"
#include "WatchyDisplay.h"
#include "WatchyRTC.h"
#include <WiFi.h>
#include <WiFiUdp.h>
#include <NTPClient.h>

class Watchy
{
public:
  Watchy();
  void Init();
  void DeepSleep();
  void VibeMotor(uint8_t intervalMs = 100, uint8_t length = 20);
  float GetBatteryVoltage();
  void ConnectWiFi();
  void SyncNTPTime();
  void DisconnectWiFi();
  void ShowWatchFace(bool partialRefresh = false);

  virtual void DrawWatchFace() = 0;

protected:
  static void DisplayBusyCallback(const void *);

  static WatchyDisplayBase m_displayBase;
  static GxEPD2_BW<WatchyDisplayBase, WatchyDisplayBase::HEIGHT> m_display;
  static WatchyRTC m_RTC;
};